#!/usr/bin/perl -w

############################################################
# Programm zum Fernsehen mit der WinTV PVR und ivtv Tools
# Autor: Helmut Fahrion
# E-Mail: hefa@gmx.net
# Lizenz: GPL
# Datum: 07.2004
#############################################################

# use strict; # das lassen wir lieber !

# Tk Module 
use Tk;
use Tk::BrowseEntry;

# TV Module ivtv
use Video::Frequencies 0.03;
use Video::ivtv 0.12;

# Damit man den Verfgbaren Speicherplatz anzeigen kann
use Filesys::Df;

# Perl, ist schon dabei...
use Getopt::Long qw(:config no_ignore_case bundling);

# ---- Pfad wo die Programm und Dokudateien sind ----------------------------
$instpath	= "$ENV{HOME}/tktv/";
$progname	= "tktv.pl";

# ---------- Aufnahme Kind ---------------
$child_hop 	= 0;
$child_tv 	= 0;
$child_aufnahme	= 0;

# --- Falls es keine lokale Installation gibt -------------------------------
$instpath = "/opt/tktv" unless( -e $instpath);

# ---- Farbe fr die Oberflche, sollte zum Thema passen --------------------
# $palette    = "gray80";
$palette    = "honeydew3";

$configfile = "$ENV{HOME}/.tvgui";
$kanalfile  = "$ENV{HOME}/.tvgui_progs";


# ---- Vom Nutzer eingebbare Optionen,
# 	werden auch in der Konfigurationsdatei gespeichert ------------------- 
%settings = (
  # start TV
  VideoStandard  => "PAL",
  Input          => "Tuner 0",
  FrequencyTable => "pal-europe",
  StartKanal     => E5,
  # Zeit fr die Aufnahme
  RecTime	 => 45,
  
  # Vorgaben
  VideoDevice    => "/dev/video0",
  # mplayer hngt sich auf wenn er nach dem ersten laden der Kernelmodule
  # gleich mit der Option -tv gestartet wird
  #MpegPlayer     => "/usr/local/bin/mplayer  -quiet -tv brightness=90:saturation=50",
  MpegPlayer     => "/usr/local/bin/mplayer -quiet",
  MEncoder 	 => "/usr/local/bin/mencoder",

  # Editlist File
  DivxCut	=> "/home/hefa/video/schnitt.divx",
  # Optionen um aus dem Video eine DIVX zu machen, ist einfach kleiner
  DivxOac 	 => "-oac lavc -lavcopts acodec=mp3:abitrate=256",
  # Output aus der TV Karte sind 16000 kbit/s (2000kbyte/s) es sind etwa
  # 2800 MB
  # DVD Qualitt sind 8000 kbit 
  # 

  # DIVX  in kbit
  # Bitrate 4000 sehr gute Qualitt, werden 1318MB
  # Bitrate 3000 sehr gute Qualitt, werden 1043MB  sehr gute Wahl!
  # Bitrate 2300 sehr gute Qualitt, werden 830MB
  # Bitrate 2000 sehr gute Qualitt, werden 740MB
  # Bitrate 1800 2 Pass gute Qualitt, werden 652MB
  # Bitrate 1100 schlechte Qualitt, etwa 400MB
  # SVCD 
  # Bitrate 1550 mittelmssige Qualitt, werden 840MB (berechnet)
  # DVD
  # Bitrate 4000 sehr gute Qualitt, werden 1253MB  
  #                                        (aufgerundet es waren 3750kbit/s)

  DivxOpts 	 => "-vf hqdn3d -ovc lavc -lavcopts vcodec=mpeg4:vbitrate=3000",
  DivxDatei	 => "/home/hefa/video/aufnahme",
 
  AufnahmeDatei  => "/home/hefa/video/aufnahme.mpeg",
  TimeShiftDatei => "/home/hefa/video/aufnahme-timeshift.mpeg",

  FrequencyTune	 => 0,
      
  ImageGrap   	 => "-nosound -frames 5 -vo gif89a -vf scale=200:150",

  # ------ MSP Matrix settings -----------
  SetMSPMatrix      => 1,
  MSPInput          => 3,
  MSPOutput         => 1,
  MSPSleep          => 2,  # number of seconds the card needs before we can set the msp matrix.
  TunerNum	    => 0,
  # --- Programmmode   	0 = TV Programm mit GUI
  # 		 	1 = Videorecorder nur Aufnahme, keine Kompression
  # 		 	2 = Aufnahme + DIVX
  RecordMode	    => 0,
  
  # Kommando um den Rechner nach der Aufnahme auszuschalten
  ShutdownCmd	    => "/bin/sleep 7; /usr/bin/sudo /sbin/halt",
  Shutdown	    => 0,     # 1=Ja oder 0=Nein
);
@aufnahme_format = ([ "MPEG", 1 ], [ "DIVX", 2]);
$nach_aufnahme  = 1;

# fehlende Programme werden noch in der .tvgui_progs gelesen
# Programm hash
%progs = (
 23 => "Pro7",
 26 => "SuperRTL",
 27 => "DSF",
);

# Programm Array, um die Reihenfolge zu speichern
@userprog = ( ["Arte", SE7],   );
@progs_keys = [ ];
$prog_anz = 0;

# ------------------------ Block mit Globalen Daten -------------------------
@standards = (["NSTC", "0"], ["PAL", "1"]);
%name2std  = (); # um die ID's zu ermitteln
 
# --- aktuelle Videostandard ---------------------
$curstd     = "PAL";
# --- Pfad wo die Doku steht ---------------------
$doku       = "$instpath/doku";
# --- Ausgabetext --------------------------------
$statustext = "Statuszeile...";
# --- Datei in der das Vorschau-Dia gespeichert ist ---
$dia_file   = "out.gif";
$dia_w	    = 200;
$dia_h      = 150;


$inputs 	= ["Composite 0", "Tuner 0" ];
%name2input	= (); # ID Ermittlung
$curinput	= "Tuner 0";

$curtable	= "pal-europe";
@curtablelist	= ();
$curtableanz	= 0;
$curtablepos	= 0;
$curchannel 	= "21";  # Darf am Anfang nicht gleich dem Startkanal sein!
$curFreq 	= 0;  # Frequenz zum tunen

$mbpro_minute	= 60.0;  # MB pro Minute Aufnahmestrom

my $tuner;	# Filedescriptor auf den Tuner
$tunerFD=0;

# Options _ ist Trenner,  File_Options_Readonlyoption 
@editors = (
  "/usr/local/bin/gvim_-f -geometry 80x43_-R", 
  "/opt/kde3/bin/kwrite_-geometry 80x43_ ", 
  "/usr/X11R6/bin/xedit_ _ ", 
  "/opt/gnome2/bin/gedit_ _ ",
);

@browsers = (
 "/opt/kde3/bin/konqueror", 
 "/usr/bin/amaya", 
 "/usr/X11R6/bin/mozilla");

$versionsfile   = "$instpath/tv-version.h";
$version        = 0;

open(D, $versionsfile) || die "Fehler beim lesen der Datei $versionsfile\n";
while ( <D> ) {
   if ( /#define version/ )
   {
     /"(.*)"/;
     $version = $1;
   }
}
close(D);

# ------------------------ Lese Konfigurationsdaten  -------------------------
config_read();

# ----- Erzeuge ein Video-Objekt -----------
$ivtvObj = Video::ivtv->new();


# ------------- Nutzer Eingabe -> Kommandozeile ----------------
%mappings = (
    AufnahmeDatei       => "a|recfile",
    DivxOac             => "b|audio",
    DivxCut             => "c|cut",
    VideoDevice       	=> "d|device",
    MEncoder            => "e|mencoder",
    FrequencyTable      => "f|table",
    TimeShiftDatei      => "g|timeshiftfile",
    Help                => "h|help",
    Input               => "i|input",
    Shutdown            => "j|halt",
    StartKanal          => "k|startkanal",
    DivxOpts            => "m|divxopts",
    DivxDatei           => "n|divxfile",
    ShutdownCmd         => "o|haltcmd",
    MpegPlayer          => "p|mpegplayer",
    RecordMode          => "r|recordmode",
    VideoStandard       => "s|standard",
    FrequencyTune       => "t|tune",
    Version             => "v|version",
    ImageGrap           => "x|grap",
    RecTime             => "z|rectime",
# alle sollten sich in $settings befinden
);

my %opts;
GetOptions(\%opts, $mappings{Help}, $mappings{Version}, 
    "$mappings{VideoDevice}=s", 
    "$mappings{VideoStandard}=s",
    "$mappings{Input}=s",
    "$mappings{FrequencyTable}=s",
    "$mappings{StartKanal}=s",
    "$mappings{FrequencyTune}=s",
    "$mappings{MpegPlayer}=s",
    "$mappings{MEncoder}=s",
    "$mappings{AufnahmeDatei}=s",
    "$mappings{RecTime}=s",
    "$mappings{RecordMode}=s",
    "$mappings{TimeShiftDatei}=s",
    "$mappings{ImageGrap}=s",
    "$mappings{DivxDatei}=s",
    "$mappings{DivxOpts}=s",
    "$mappings{DivxCut}=s",
    "$mappings{DivxOac}=s",
    "$mappings{Shutdown}=s",
    "$mappings{ShutdownCmd}=s",
);

# ----------------- Hilfeausgaben  ----------------
sub usage
{
  my $errorCode = shift;
  my $error = shift;

  my $usageStr = "\ntktv $version Helmut Fahrion (c) 2004\n".
        "\n".
        "Benutzung:    tktv.pl ";

  foreach my $opt (sort values %mappings)
  {
    $usageStr = $usageStr." [$opt=value]";
  }

$usageStr = $usageStr.
"\n".
"Kommandozeilenoptionen: \n".
"    -h | --help                Hilfeausgabe.\n".
"    -a | --recfile <dateiname> Datei in der die Aufnahme gespeichert wird\n".
"    -b | --audio <string>      Die Optionen fr die Audio Kodierung\n".
"    -c | --cut <dateiname>     Name der Schnittdatei fr das Divx\n".
"    -g | --timeshiftfile <dateiname>\n".
"                               Datei in der die Aufnahme fr das Timeshift\n".
"                               gespeichert wird.\n".
"    -d | --device <device>     Device der Videokarte, z.B. /dev/video0\n".
"    -e | --mencoder <encoder>  Kodierungsprogramm, /usr/local/bin/mencoder\n".
"    -f | --table <tabelle>     Freqenztabelle, z.B. pal-europe\n".
"    -i | --input <input>       Input auf der Karte, Tuner 0 oder S-Video\n".
"    -k | --startkanal <kanal>  Kanal, z.B. E5\n".
"    -l | --lavopts <string>    Encoderoptionen um das AVI fuer die lavtools\n".
"                               zu erzeugen.\n".
"                             \"-oac pcm -ovc lavc -lavcopts vcodec=mjpeg\"\n".
"    -p | --mpegplayer <player> Anzeigeprogramm, z.B. /usr/local/bin/mplayer\n".
"    -r | --recordmode <mode>   1 Programm startet ohne GUI und staret die \n".
"                               Aufnahme, Aufnahmedatei ist MPEG\n".
"                               2 Programm startet ohne GUI und nimmt auf,\n".
"                               Aufnahmedatei wird in DIVX umgewandelt.\n".
"    -s | --standard <Videostandard> PAL, SECAM oder NSTC.\n".
"    -t | --tune <frequenz>     2, werden immer 2Mhz zum Kanal addiert.\n".
"    -x | --grap                Optionen zum Speichern des Dias.\n".
"    -v | --version             Ausgabe der Versionsnummer.\n".
"    -z | --rectime <zeit>      Die Aufnahmedauer.\n".
"\n".
"Konfigurationsfile:\n".
"\n".
"    \$HOME/.tvgui\n".
"\n".
"    Mit \"Speichern\" wird das File erzeugt. Die Kommandozeilenoptionen\n".
"    wirken ber denen im Konfigurationsfile.\n".
"\n";

  print $usageStr;
  print "\nError:  $error\n" if ($errorCode == 1);
  print "$error\n" if ($errorCode == 2);

  my_exit($errorCode);
}

foreach my $option (keys %opts)
{
  foreach my $mapName (keys %mappings)
    {
     # handle the non-settings cases.
     if ($option =~ /^($mappings{Version})$/)
       {
	  show_string("Version: $version");
	  my_exit(0);
       }
       elsif ($option =~ /^($mappings{Help})$/)
       {
	  usage(0, "");
	  my_exit(0);
       }
       elsif ($option =~ /^($mappings{$mapName})$/)
       {
	 $settings{$mapName} = $opts{$option};
	 show_string("$mapName = '$opts{$option}'");
       }
    }
			      
} 

# ------------------ erzeuge ein Hauptfenster --------------------------------
$centry = BrowseEntry;
$sentry = BrowseEntry;
$ientry = BrowseEntry;

sub makeGUI
{
  $top = MainWindow->new();
  $top->title("PVR TV");
  $top->setPalette($palette);
  # ---------------------------- Arbeitsbereiche ------------------------------

  my @main_packer = qw/-side top -fill x/;
  my $menubar = $top->Frame(-relief => 'raised', -borderwidth => 2)->pack(@main_packer);

  my @work_packer = qw/-side top -fill both -expand yes/;
  my $work = $top->Frame(-relief => 'sunken', -borderwidth => 2)->pack(@work_packer);

  # ---------------------------- Bedienflche ---------------------------------

  my @pu = qw/-side top -expand yes -fill both -pady 1m/;
  my $f1 = $work->Frame(-relief => 'raised', -borderwidth => 1)->pack(@pu);
  my @po = qw/-side right -expand yes -fill y -pady 1m/;
  my $fentry = $f1->Frame(-relief => 'raised', -borderwidth => 1)->pack(@po);


  # Entry Std
  my(@pe) = qw/-side top/;
  my $label;
  $sentry = $fentry->BrowseEntry(-state => "readonly",
		   -browsecmd => \&change_std,
		   -variable => \$curstd);
  foreach $label (@standards) {
    $sentry->insert("end", $label->[0] );
    # print "std: ".$label->[0];
  }
  $sentry->pack(@pe);

  $ientry = $fentry->BrowseEntry(-state => "readonly",
		   -browsecmd => \&change_input,
		   -variable => \$curinput);
    foreach $label (@inputs) {
      $ientry->insert("end", $label);
    }
  $ientry->pack(@pe);


  my $tentry = $fentry->BrowseEntry(-state => "readonly",
		   -browsecmd => \&change_table,
		   -variable => \$curtable);
  foreach $label (sort keys %CHANLIST) {
    $tentry->insert("end", $label);
   # print "map: ".$label;
  }
  $tentry->pack(@pe);

  $centry = $fentry->BrowseEntry(-state => "readonly",
		   -browsecmd => \&change_channel,
		   -variable => \$curchannel);
  my @curtablelist = sort { $a cmp $b } keys %{$CHANLIST{$curtable}};
  my $curtableanz = @curtablelist;
  foreach $label ( @curtablelist) {
	  $centry->insert("end", $label);
    #print "Kanal: ".$label."\n";
  }
  $centry->pack(@pe);


  # --- Channel Scan Buttons ---------
  my(@pr) = qw/-side top -fill x -pady 1m/;
  my $fcb = $fentry->Frame(-relief => 'sunken', -borderwidth => 1)->pack(@pr);
  my $startbutton =	$fcb->Button(
		  -text => 'TV',
		  -command => [\&start_monitor, 720, 576, ""])
		  ->pack(qw/-side left/);
		  
  my $monitorbutton =	$fcb->Button(
		  -text => 'Monitor',
		  -command => [\&start_monitor, 360, 288, "-geometry 100%:100% -rootwin"])
		  ->pack(qw/-side left/);
  $monitorbutton->focus();
		  
  my $timeshiftbutton =	$fcb->Button(
		  -text => 'TS',
		  -command => [\&start_ts, 360, 288])
		  ->pack(qw/-side left/);

  my $fcb2 = $fentry->Frame(-relief => 'sunken', -borderwidth => 1)->pack(@pr);

  my $button_scannext = $fcb2->Button(
			  -text => 'Kanal+',
			  -command => [\&scan_next])
				  ->pack(qw/-side left/);

  my $button_killtv = $fcb2->Button(
			  -text => 'kill TV',
			  -command => [\&kill_tv])
				  ->pack(qw/-side left/);
  # --- zur Auflockerung der GUI ein Bildchen ... ---
  my $fcbp = $fentry->Frame()->pack(@pr);
  $photo = $top->Photo('bildchen', -data => &encoded_gif, -format => 'gif',
  	-width => $dia_w, -height => $dia_h);
  my $picbutton = $fcbp->Button(
  		  -text => "Dia",
		  -image => $photo,
		  -command => [\&new_frame])
		  ->pack(qw/-side left/);
  
  if ( -e $dia_file )
  {
    $photo->configure(-file => $dia_file, -width => $dia_w, -height => $dia_h);
  }
  
  # --- Logo ---
  my $fcbp2 = $fentry->Frame()->pack(@pu);
				  
  my $c2 = $top->Photo('logo', -file =>  Tk->findINC("anim.gif"));
  my $logobutton = $fcbp2->Button(
			  -image => $c2,
			  -borderwidth => 0,
			  -command => [\&show_perl])
				  ->pack(qw/-side bottom/);
				  
  @pu = qw/-side top -fill x -pady 1m/;
  my @pb = qw/-side top -fill y -pady 1m/;
  my $frame2 = $f1->Frame(-relief => 'sunken', -borderwidth => 1)->pack(@pu);
  my $frame3 = $f1->Frame(-relief => 'sunken', -borderwidth => 1)->pack(@pu);
  my $frame4 = $f1->Frame(-relief => 'sunken', -borderwidth => 1)->pack(@pb);

  my $ladebutton =	$frame2->Button(
		  -text => 'insmod',
		  -command => [\&lade_module])
		  ->pack(qw/-side left/);

  my $entladebutton =	$frame2->Button(
		  -text => 'rmmod',
		  -command => [\&entlade_module])
		  ->pack(qw/-side left/);
		  
  my $plusbutton =	$frame2->Button(
		  -text => '+',
		  -command => [\&tune_plus])
		  ->pack(qw/-side left/);
		  
  my $minusbutton =	$frame2->Button(
		  -text => '-',
		  -command => [\&tune_minus])
		  ->pack(qw/-side left/);

  my $aufnahmebutton =	$frame3->Button(
		  -text => 'REC',
		  -command => [\&start_aufnahme])
		  ->pack(qw/-side left/);
		  
  my $stopbutton =	$frame3->Button(
		  -text => 'STOP',
		  -command => [\&stop_aufnahme])
		  ->pack(qw/-side left/);
		  
  my $divxbutton =	$frame3->Button(
		  -text => 'DIVX',
		  -command => [\&start_konv, 1, ".divx"])
		  ->pack(qw/-side left/);
  
  my $showrec 	 = 	$frame3->Button(
		  -text => 'PlayR',
		  -command => [ \&start_show ])
		  ->pack(qw/-side left/);

  # --- Programm-Buttons laden ----------------------------------------
  my $fz = 0;
  $frame_zeile[$fz] = $f1->Frame(-relief => 'sunken', -borderwidth => 1)
	  ->pack(qw/-side top -fill x /);

  my $prognum = 0;

  my $prog;
  my $y = 0;
  foreach $prog ( @userprog ) 
  {
    if ( $y == 4 )
    {
      $y = 0;
      $fz ++;
      $frame_zeile[$fz] = $f1->Frame(-relief => 'sunken', -borderwidth => 1)
	  ->pack(qw/-side top -fill x /);
    }
    $prog_buttons [$prognum] = 
	$frame_zeile[$fz]->Button(
	     -text => $prog->[0],
	     -command => [\&channel_button, $prog->[1], $prognum])
	     ->pack(qw/-side left/);
    $prognum++;
    $y++;
  }
      
  # --- Programm-Button next ---
  $fz++;
  $frame_zeile[$fz] = $f1->Frame(-relief => 'sunken', -borderwidth => 1)
	  ->pack(qw/-side top -fill x /);

  $prognum++;
  $prog_buttons [$prognum] = 
      $frame_zeile[$fz]->Button(
	     -text => "+",
	     -command => [\&channel_next])
	     ->pack(qw/-side left/);
  $prognum++;
  $prog_buttons [$prognum] = 
      $frame_zeile[$fz]->Button(
	     -text => "-",
	     -command => [\&channel_prev])
	     ->pack(qw/-side left/);
  $prognum++;
  $prog_buttons [$prognum] = 
      $frame_zeile[$fz]->Button(
	     -text => "hop",
	     -command => [\&channel_hop])
	     ->pack(qw/-side left/);
  $prognum++;
  $prog_buttons [$prognum] = 
      $frame_zeile[$fz]->Button(
	     -text => "stop",
	     -command => [\&channel_stop])
	     ->pack(qw/-side left/);


  # ------------------ Statuszeile -----------------------------------------
  my @status_packer = qw/-side top -fill x -anchor sw/;
  my $status = $top->Frame(-relief => 'raised', -borderwidth => 1)->pack(@status_packer);
  my $status_l1 = $status->Entry(-relief => 'sunken', -width => 60,
      -textvariable => \$statustext)->pack(@status_packer);

  # ------------------- Menue ----------------------------------------------

  my @menue_packer = qw/-side left -padx 1m/;
  my $f = $menubar->Menubutton(qw/-text Datei -underline 0 -menuitems/ =>
     [
	  [Button => 'Neuer Timer/Cronjob...', -underline => 0, -command => [\&my_timer , 0]],
	  [Button => 'Bearbeite Cronjobs...', -underline => 0, -command => [\&my_cron , 0]],
	  [Separator => ''],
	  [Button => 'Quit/Ende', -underline => 0, -command => [\&my_exit , 0]],
    ])->pack(@menue_packer);


  my $f2 = $menubar->Menubutton(qw/-text Einstellungen -underline 0 -menuitems/ =>
	  [
	  [Button => 'Speichern', -underline => 0,  -command => [\&config_save]],
	  [Button => 'Laden', -underline => 0,   -command => [\&config_read]],
	  [Separator => ''],
	  [Button => 'Divx Schnitt...', -underline => 0,  
				     -command =>  [\&show_editor, 
				     	$settings{DivxCut}, ""]],
	  [Button => 'Konfigurieren...', -underline => 0,  
				     -command =>  [\&show_editor, $configfile, ""]],
	  [Button => 'Programme...', -underline => 0,   
				     -command =>  [\&show_editor, $kanalfile, ""]],
    ])->pack(@menue_packer);


  @menue_packer = qw/-side right -padx 3m/;
  my $m = $menubar->Menubutton(qw/-text Hilfe -underline 0 -menuitems/ =>
     [
	[Button => 'Version ...',    -command => [\&show_version]],
	  [Separator => ''],
	[Button => 'Quelle gui ...', -command => [\&show_editor, 
					  "$instpath/doku/tktv.pl", "-R"]],
	  [Separator => ''],
	[Button => 'Programmdoku ...',    -command => [\&show_doku]],
	[Button => 'README ...',    -command => [\&show_editor, 
					  "$instpath/README", "-R"]],
	  [Separator => ''],
	[Button => 'Lizenz ...',    -command => [\&show_editor, 
					  "$doku/gpl.txt", "-R"]],
	   ])->pack(@menue_packer);

  #****************************************************************************
  #*	GUI fertig !
  #****************************************************************************
}

# ------ Neuen Frame anzeigen ------------------------------------------
sub new_frame {
    my $w = $dia_w;
    my $h = $dia_h;
    
    $statustext = "grab neuen Frame...";
    show_string($statustext);
  
    # --- PAL Auflsung ---
    my $result = $ivtvObj->setResolution($tunerFD, 720, 576);
    
    if (not defined $result || !$result)
    {
      show_string("setResolution($tunerFD, $w, $h) failed!");
    }
    else
    {
      # " -nosound -frames 5 -vo gif89a -vf scale=200:150 "
      show_string("setResolution($tunerFD, $w, $h)...OK!");
      system $settings{MpegPlayer}." ".
             $settings{ImageGrap}." ".
	     $settings{VideoDevice};
      $photo->configure(-file => $dia_file, -width => $w, -height => $h);
    }

}

sub show_editor {
  my $file;
  my $opt;
  my $ro;

  # Zuerst $EDITOR verwenden
  my $editor = $ENV{EDITOR};
  if ( defined $editor )
  {
    $statustext = "sytem: \$EDITOR mode:$_[1]";
    show_string($statustext);
    system "$editor $_[0] $_[1] &";
    return;
  }


  # Ist das Programm vorhanden ?
  foreach (@editors)
  {
    ($file, $opt, $ro) = split(/_/, $_);
    $statustext = "sytem: file->$file opt->$opt ro->$ro mode:$_[1]";
    show_string($statustext);

    # falls mehrere Optionen
    if ( -e $file)
    {
       unless ($_[1] cmp "-R")
       {
    system "$file $opt $ro $_[0] &"; # hier wird der komplette Aufruf genommen
       }
       else
       {
    system "$file $opt $_[0] &"; # hier wird der komplette Aufruf genommen
       }
       goto ende; 
  }
}
ende:
}

# ------ Browser starten --------------------------------------------
sub show_doku {
  # Ist das Programm vorhanden ?
  foreach (@browsers)
  {
    if ( -e $_)
    {
       system "$_"." $doku/index.html &";
       goto ende; 
    }
  }
ende:
}
sub show_perl {
  # Ist das Programm vorhanden ?
  foreach (@browsers)
  {
    if ( -e $_)
    {
       system "$_"." http://www.perltk.org &";
       return; 
    }
  }
}



# --------------------- Speichern der globalen Daten  ------------------------
sub save_settings
{
  print D "\$settings\{$_[0]\} = \"$settings{$_[0]}\"\;\n\n";
}
sub save_settings_set
{
  print D "\$settings\{$_[0]\} = \"$_[1]\"\;\n\n";
}

sub config_save {
  open(D, ">$configfile") ||die "Fehler beim schreiben der Datei $configfile\n";

# --------------------------- alle globale Variablen --------------------------
  print D "# Versionsnummer \n";
  print D "\$version = \"$version\"\;\n";
  print D "# Primrer Installationspath, wo die Shell-Scripte gesucht werden. \n";
  print D "\$instpath = \"$ENV{HOME}/tktv\"\;\n";
 
  print D "\n# Bei folgenden Eingaben wird der aktuelle Stand der\n";
  print D "# Applikation gesichert.\n";
  print D "# PAL SECAM oder NSTC  je nach Tuner und Land\n";
  save_settings_set( VideoStandard, $curstd );
  print D "# Welches Input wird beim Start gesetzt \n";
  save_settings_set( Input, $curinput );
  print D "# je nach Anbieter und Region \n";
  save_settings_set( FrequencyTable, $curtable );
  print D "# der zuletzt gewhlte Kanal wird zum Startkanal \n";
  save_settings_set( StartKanal, $curchannel );
  print D "# ein + oder - fr das Fine-Tuning \n";
  save_settings( FrequencyTune );
  
  print D "\n# folgenden Eingaben sind nur hier nderbar.\n";
  print D "# /dev/video oder /dev/video2  je nachdem welche Karte \n";
  save_settings( VideoDevice);
  print D "# das Programm welches zum Fernsehen verwendet wird, sollte MPEG knnen\n";
  save_settings( MpegPlayer);
  print D "# zur DivX - Umwandlung \n";
  save_settings( MEncoder);
  
  print D "# Die Ausgabedatei fr das DivX\n";
  save_settings( DivxDatei );
  
  print D "# Optionen um die DivX zu erzeugen \n";
  save_settings( DivxOpts );

  print D "# Optionen fr die Audio Kodierung \n";
  save_settings( DivxOac );
  
  print D "# Dateiname in der die Schnittmarken fr das DivX stehen \n";
  save_settings( DivxCut );
  
  print D "# wohin mit den MPEG-Daten der Aufnahme \n";
  save_settings( AufnahmeDatei);
  # Zeit fr die Aufnahme
  print D "# die Zeitvorgabe fr die Aufnahme \n";
  save_settings( RecTime );
  
  
  print D "# Aufnahmedatei fr das Timeshift \n";
  save_settings( TimeShiftDatei );

  print D "# Optionen zum Dia schreiben \n";
  save_settings( ImageGrap );

  print D "# Kommando zum Rechner runterfahren \n";
  save_settings( ShutdownCmd );

  print D "\n";
  close(D);
}

# ------------------------- Lesen der globalen Daten  -----------------------
sub config_read {
  if ( open(D, "$configfile") )
  {
    # ---- configfile ist gleich ein perlprogramm ! --------
    while ( <D> ) { eval $_; }
  
    close(D);
  }
  
  if ( open(K, "$kanalfile") )
  {

    # ---- Zeilen im Config-File sind Perlanweisungen ! --------
    while ( <K> ) { eval $_; }
  
    close(K);

    my $prog;
    
    # Hash aufbauen
    my $x = 0;
    foreach $prog (@userprog) {
      if ( $prog->[1] )
      {
        $progs{$prog->[1]} = $prog->[0];
	
	# keys in der Reihenfolge des Benutzers
	$progs_keys[$x] = $prog->[1];
	$x++;
      }
    }
    
    $prog_anz = @progs_keys;
  }
  else
  {
    print "Kann Kanal-Datei nicht finden, bitte $kanalfile anlegen!\n";
  }
}

# ----------------- Dialogbox fr die Versionsnummerausgabe  ----------------
sub show_version {
  $top->messageBox(-icon => 'info', -type => 'OK', -title => 'Information', 
  				-message => "Version: $version");
} # end show_version


# ---------- Editiert Crontabeintrge  ----------------

$timers_stunde = 12;
$timers_minute = 23;
$timers_tag = 24;
$timers_monat = 10;
$timers_wochentag = "*";
$timerf_minuten = 45;
$timer_kanal=$settings{StartKanal};


sub my_cron {
    $statustext = "crontab -e &";
    show_string($statustext);
    system $statustext;
}

# ---------- Schreibt Crontabeintrge  ----------------
sub write_crontab {
    my $crontmp = ".tvgui-crons";

    my $platz = df_sub();
    # --- ein bischen Konsistenzprfung ---
    #  Lnge nicht > df_sub() 
    if ($timerf_minuten  > $platz)
    {
      $statustext = "Nicht ausreichent Platz fr $timerf_minuten Minuten verfgbar!";
      show_string($statustext);
      return;
    }

    # leerzeichen weg
    $_ = $settings{Input};
    s/\s/_/g;
    my $input = $_;

    # bastele crontab String zusammen
    my $cronstr = "$timers_minute $timers_stunde $timers_tag $timers_monat $timers_wochentag $instpath/$progname --standard $settings{VideoStandard} --input $input --table $settings{FrequencyTable} --startkanal $timer_kanal --rectime $timerf_minuten --recordmode $nach_aufnahme --halt $settings{Shutdown}";
    
    # Minuten nicht negativ
    print "write_crontab! str=\"$cronstr\"\n";

    # User Crontab geben lassen
    system "crontab -l > $crontmp";

    # Daten eintragen
    open(D, ">> $crontmp") || die "Fehler beim oeffnen der Datei $crontmp\n";
    print D $cronstr."\n";
    close(D);

    # User Crontab installieren
    system "crontab $crontmp";
    
}

# ---------- Timer Programmierung  ----------------
sub my_timer { 
    my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
      localtime(time);
					  
    $timers_stunde = $hour;
    $timers_minute = $min;
    $timers_tag = $mday;
    $timers_monat = $mon + 1; # --- geht von 0-11 ! ---

    my $toplevel = MainWindow->new;
    $toplevel->setPalette($palette);
    $toplevel->title("Timer Programmierung");
    
    my @pu = qw/-side top -expand yes -pady 1m/;
    my $toplabel = $toplevel->Label(-text => 'Start:')->pack(@pu);
    my $topl = $toplevel->Frame(-relief => 'raised', -borderwidth => 1)->pack(@pu);
    
    # --- Aufnahme Start ---	
    my(@sl) = qw/-side left -padx 2m -fill x -anchor nw/;
    my $f3 = $topl->Frame->pack(@pu);
    my $left_l3 = $f3->Label(-text => 'Stunde [0-23]:')->pack(@sl);
    my $tstunde = $f3->Entry(-relief => 'sunken', -width => 4,
	-textvariable => \$timers_stunde)->pack(@sl);
	
    my $left_l4 = $f3->Label(-text => 'Minute [0-59]:')->pack(@sl);
    my $tminute = $f3->Entry(-relief => 'sunken', -width => 4,
	-textvariable => \$timers_minute)->pack(@sl);
    
    my $f4 = $topl->Frame->pack(@pu);
    my $left_fm = $f4->Label(-text => 'Monat [1-12]|*|,:')->pack(@sl);
    my $fm = $f4->Entry(-relief => 'sunken', -width => 4,
	-textvariable => \$timers_monat)->pack(@sl);
    my $left_ft = $f4->Label(-text => 'Tag [1-31]|*|,:')->pack(@sl);
    my $ft = $f4->Entry(-relief => 'sunken', -width => 4,
	-textvariable => \$timers_tag)->pack(@sl);
	
    my $f5 = $topl->Frame->pack(@pu);
    my $left_fw = $f5->Label(-text => 'Wochentag [0-7]')->pack(@sl);
    my $ftw = $f5->Entry(-relief => 'sunken', -width => 4,
	-textvariable => \$timers_wochentag)->pack(@sl);
    my $left_fwt = $f5->Label(-text => '0 oder 7 ist Sonntag')->pack(@sl);


    # --- Aufnahme Stop ---	
    my $toplabel2 = $toplevel->Label(-text => 'Stop:')->pack(@pu);
    my $topl2 = $toplevel->Frame(-relief => 'raised', -borderwidth => 1)->pack(@pu);

    
    # --- Ermittle dynamisch die maximal mglichen Aufnahmeminuten ---
    my $f3f = $topl2->Frame->pack(@pu);
    my $strminfree = sprintf("Minuten [1-%d]:", df_sub());
    my $left_l3f = $f3f->Label(-text => $strminfree)->pack(@sl);
    my $tminuten = $f3f->Entry(-relief => 'sunken', -width => 4,
	-textvariable => \$timerf_minuten)->pack(@sl);
    my $stop = $f3f->Checkbutton(-text => 'Abschalten', 
    				 -variable => \$settings{Shutdown}, 
				 -relief => 'flat')->pack(@sl);

    my $haltl = $topl2->Frame->pack(@pu);
    my $halt_optlabel = $haltl->Label(-text => "Kommpression:")->pack(@sl);
    
    
    foreach my $b ( @aufnahme_format ) {
      $haltl->Radiobutton(-relief => 'sunken', 
               -text => $b->[0],
	       -variable => \$nach_aufnahme,
	       -value => $b->[1]
           )->pack(qw/-side left/);
    }
    
	
    # --- Aufnahme Stop ---	
    my $toplabel3 = $toplevel->Label(-text => 'Programm:')->pack(@pu);
    my $line=0;
    my $lcnt=4;
    
    # --- default wert ---
    $timer_kanal = $curchannel;
    foreach my $p ( @userprog ) {
	if ($lcnt == 4)
	{
	  $lcnt = 0;
	  $line ++;
	  $frl[$line] = 
          $toplevel->Frame(-relief => 'raised', -borderwidth => 1)
  	        ->pack(qw/-side top -fill x /);
	}

	$lcnt++;
	$frl[$line]->Radiobutton(# -relief => 'sunken', 
	    -text => $p->[0],
	    -variable => \$timer_kanal,
	    -value => $p->[1])->pack(qw/-side left/);
    }
	
    my $f7 = $toplevel->Frame->pack(@pu);
    my $cancel = $f7->Button(-text => 'Zu',
	    -command => sub { destroy $toplevel })
	    ->pack(qw/-side left -padx 2m -pady 2m/);
    my $ok = $f7->Button(-text => 'Fertig',
	    -command => sub { write_crontab; destroy $toplevel })
	    ->pack(qw/-side left -padx 2m -pady 2m/);

} # end my_timer


$line = "---------------------------------";
sub show_string {
  print "$_[0]\n";
}

# ------------ Funktion zum Laden der Kernelmodule  -------------
sub lade_module {
  system "$instpath/ivtv_load ";
  $statustext = "lade Kernelmodule...fertig!";
  show_string($statustext);

  # gleich den Status auslesen
  unless (get_status())  # die Widgets sollen initialisert werden
  {
    set_default_first();
    show_string("Get_Status OK!");
  }

  show_string($line);
} # lade module

# ------------ Funktion zum Entladen der Kernelmodule  -------------
sub entlade_module {
  # tuner schlieen...
  $tunerFD = 0;
  close($tuner);
  system "$instpath/ivtv_unload ";
  $statustext = "entlade Kernelmodule...fertig!";
  show_string($line);
} # entlade module

# ------------ Funktion starten eines MPEG Players -------------
sub start_monitor {
  my $result = $ivtvObj->setResolution($tunerFD, $_[0], $_[1]);
  
  if (not defined $result || !$result)
  {
    show_string("setResolution($tunerFD, $_[0], $_[1]) failed!");
  }
  else
  {
    show_string("setResolution($tunerFD, $_[0], $_[1])...OK!");
  }

  my $str = "$settings{MpegPlayer} $settings{VideoDevice} $_[2]";
  $statustext = "Starte Mpeg Player: $str";
  show_string($statustext);
  show_string($line);
 
  my $child = fork;
  die "Error:  fork() failed!\n" unless (defined $child);
  
  # ------ Kind startet Monitor mit "exec" somit werden Signale empfangen! ---
  exec($str) if ($child == 0);
  
  $child_tv = $child;
}

# --- Starte Time_Shift ---
sub start_ts {

  # --- Starte Aufnahme, kann auch mit "STOP" angehalten werden ---
  my $result = $ivtvObj->setResolution($tunerFD, 720, 576);
  
  if (not defined $result || !$result)
  {
    show_string("setResolution($tunerFD, 720, 576) ...failed!");
  }
  else 
  {
    show_string("setResolution($tunerFD, 720, 576) ...OK!");
  }
  
  my $datei = $settings{TimeShiftDatei};
  
  rename($datei, $datei.".old");
  show_string("rename: $datei -> *.old");

  # --- es wird ein Kindprozess mit dem Kopieren der Videodaten ---
  # ---------------------- beschftigt ----------------------------
  my $child = fork;
  unless (defined $child)
  {
    # fork failed
    die "Error:  fork() failed!\n";
  }
  
  my $video = $settings{VideoDevice};

  # ------ Kopieren, hiermit erfolgt die Aufnahme des Mpegs -------
  # ------ damit mu der Film aufgenommen werden knnen ! ------
  if ($child == 0) 
  {
     # bin Kind
     # - starte Aufnahme -
     open(V, "<$video") || die "Fehler beim lesen der Datei $video\n";
     open(A, ">$datei") || die "Fehler beim lesen der Datei $datei\n";
     
     # ---- configfile ist gleich ein perlprogramm ! --------
     while ( <V> ) { print A $_; }
 
     # - komme hier nur im Fehlerfall an -
     close(V);
     close(A);
     exit 0; # alles OK
  }
  
  $child_aufnahme = $child;

  # ----- gebe Kind Zeit -----
  sleep 7;

  # ---- Endlos Schleife, falls man mal zuweit vorspult ----
  $statustext = sprintf("TimeShift max: %d min in %s", 
  			df_sub(), $settings{TimeShiftDatei});
  show_string($statustext);
  show_string($line);
 
  $child = fork;
  die "Error:  fork() failed!\n" unless (defined $child);
  
  # ------ Kind startet Monitor mit exec somit werden Signale empfangen
  my $str = "$settings{MpegPlayer} -loop 0 $settings{TimeShiftDatei} ";
  exec($str) if ($child == 0);
  
  $child_tv = $child;
} # Starte TV Programm

# Starte DivX Kodierung
sub start_konv {
  my $par1 = $_[0];
  my $par2 = $_[1];

  my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
      localtime(time);

  my $input =  $settings{AufnahmeDatei};
  my $encoderdat = $settings{DivxDatei};
  # my $tmpdat     = $settings{DivxDatei}*.".avi";
  my $ovc = $settings{DivxOpts};
  my $oac = $settings{DivxOac};
  
  $mon++;
  $year += 1900;
  $encoderdat = sprintf("%s-%04d%02d%02d-%02d%02d%s", $encoderdat, 
  			  $year, $mon, $mday, $hour, $min, $par2);
			  
  # keine Konvertierung, MPEG zum ansehen
  if ( $par1 == 2 )
  {
    rename($input, $encoderdat);
    $statustext = "rename: $encoderdat";
    show_string($statustext);
    return;
  }
  

  # GUI Kommando, nur VG ist 3Pass !
  if ( $par1 == 1 )
  {
    if ( -e $settings{DivxCut} )
    {
       $divx_von = "00:00:00";
       $divx_bis = "99:99:99";

	open(C, "$settings{DivxCut}") || die "Kann $settings{DivxCut} nicht oeffnen!\n";
	  # ---- configfile ist gleich ein perlprogramm ! --------
	while ( <C> ) { eval $_; }
	close(C);
     
	$str_tmp = "$settings{MEncoder} -ss $divx_von -endpos $divx_bis";
    }
    else
    {
      $str_tmp = "$settings{MEncoder}";
    } 

  # mache richtiges 3Pass oder richtiges 2Pass draus !
  #$str = "xterm -e \"$str_tmp $input $ovc:vpass=1 -oac copy -o $tmpdat; 
  #		      $str_tmp $input $ovc:vpass=2 -oac copy -o $tmpdat;
  #                  $settings{MEncoder} $tmpdat -ovc copy $oac -o $encoderdat;
  # 	      rm -f $tmpdat\"&";

   #  Bei "-ovc frameno" werden Vorschlge fr die Bitrate gemacht,
   #  so das das Video auf eine 650, 700 oder 800er CD passt.
   #  Wird hier nicht ausgewertet, aber es wird schon mal der Audio-Kanal
   #  kodiert.
   $str = "xterm -e \"rm -f frameno.avi; \
   		      $str_tmp $input -ovc frameno $oac -o frameno.avi; 
   		      $str_tmp $input $ovc:vpass=1 -oac copy -o $encoderdat; 
   		      $str_tmp $input $ovc:vpass=2 -oac copy -o $encoderdat;
   		      rm -f frameno.avi\"&";
  } 
  else
  {
    # par == 0
    # Keine Ausgaben der Framezahlen, 1 Pass Verfahren, ist ja nur zum
    # komprimieren.
    $str = "$settings{MEncoder} -o $encoderdat $input $oac $ovc -quiet";
  }

  $statustext = "Starte Mencoder: $str";
  show_string($statustext);
  show_string($line);
  system $str;
  
} # Starte DivX Kodierung

# --- Ermitteln wieviele Minuten aufgenommen werden knnen ---
sub df_sub {
  my $ref = df("/home/hefa/video");

  show_string("DatentrgerInformation:");
  show_string("Percent Full:		$ref->{per}");
  show_string("User Blocks Available:	$ref->{bavail}");
  
  my $mb =  $ref->{bavail} / 1024;
  my $rnd = sprintf("%d", $mb);
  show_string("MegaBytes:		$rnd");
  
  $rnd = sprintf("%d", $mb / $mbpro_minute);
  show_string("AufnahmeMinuten:	$rnd");
  return $rnd;
}

sub stop_aufnahme {

  if ( $child_aufnahme != 0)
  {
    # Prozess killen
    kill(15, $child_aufnahme);

    # Freien Platz ermitteln und ausgeben
    $statustext = 
	sprintf("Stop Aufnahme, gettet pid=$child_aufnahme, frei: %d Minuten.", 
	df_sub());
    show_string($statustext);
    show_string($line);
  }
} # --- stop_aufnahme ---

# --------------------- Starte Aufnahme Betrachter ---------------------
sub start_show {
  
  my $datei = $settings{AufnahmeDatei};
  
  # beendet sich von alleine, nach 3 Sekunden,
  # da die Datei beim Stop mal zuende ist
  unless ($settings{RecordMode} )
  {
    system "$settings{MpegPlayer} $datei &";
  } 
  
  $statustext = sprintf("Starte Player. %d Minuten (Reserve).", df_sub());
  show_string($statustext);
  show_string($line);
} # Starte Aufnahme

# --------------------- Starte Aufnahme und Anzeige ---------------------
sub start_aufnahme {
  
  my $result = $ivtvObj->setResolution($tunerFD, 720, 576);
  
  if (not defined $result || !$result)
  {
    show_string("setResolution($tunerFD, 720, 576) ...failed!");
  }
  else 
  {
    show_string("setResolution($tunerFD, 720, 576) ...OK!");
  }
  
  my $datei = $settings{AufnahmeDatei};
  
  #rename($datei, $datei.".old");
  #show_string("rename: $datei -> *.old");

  # --- es wird ein Kindprozess mit dem Kopieren der Videodaten ---
  # ---------------------- beschftigt ----------------------------
  my $child = fork;
  unless (defined $child)
  {
    # fork failed
    die "Error:  fork() failed!\n";
  }
  
  my $video = $settings{VideoDevice};
  # ------ Kopieren, hiermit erfolgt die Aufnahme des MPEGs -------
  if ($child == 0) 
  {
     # bin Kind
     # - starte Aufnahme -
     open(V, "<$video") || die "Fehler beim lesen der Datei $video\n";
     open(A, ">$datei") || die "Fehler beim lesen der Datei $datei\n";
     
     # ---- Kopiervorgang --- 
     while ( <V> ) { print A $_; }
 
     # - komme hier nur im Fehlerfall an -
     close(V);
     close(A);
     exit 0; # alles OK
  }
  
  $child_aufnahme = $child;
  # ----- gebe Kind Zeit -----
  sleep 3;

  # beendet sich von alleine, nach 3 Sekunden,
  # da die Datei beim Stop mal zuende ist
  unless ($settings{RecordMode} )
  {
    system "$settings{MpegPlayer} $datei -geometry 360x288 &";
  } 
  
  $statustext = sprintf("Starte Aufnahme: maximal %d Minuten (Reserve).", df_sub());
  show_string($statustext);
  show_string($line);
} # Starte Aufnahme

# ------------ mspMatrix setzen -------------------------------
sub set_mspmatrix {
  $statustext = 
  "Setting msp matrix: input = $settings{MSPInput}, output = $settings{MSPOutput}";
  
  show_string($statustext);

  sleep ($settings{MSPSleep});  # sleep for 2 seconds to let card settle down.
  
  my $result = $ivtvObj->mspMatrixSet($tunerFD, $settings{MSPInput}, 
                                                $settings{MSPOutput});
  unless (defined $result)
  {
    die "Error calling mspMatrixSet!\n";
  }
  unless ($result)
  {
    die "Error in mspMatrixSet ioctl call!\n";
  }
}

# ------------ Funktion zum Wechseln des Standards -------------
sub change_std 
{
  $settings{VideoStandard} = $curstd;
  my $std = $name2std{$curstd};

  unless( defined $std ) 
  {
    die "Error:  setStandard($curstd) unbekannt!\n";
  }

    my $result = $ivtvObj->setStandard($tunerFD, $std);	

    unless ($result)
    {
      die "Error:  setStandard($curstd) failed!\n";
    } else
    {
      set_mspmatrix();
    }

    $statustext = "Setze Standard: $curstd";
    show_string($statustext);
} # change_std

# ------------ Funktion zum Wechseln der Frequenztabelle -------------
sub change_table 
{
   $settings{FrequencyTable} = $curtable;
   
   unless($settings{RecordMode} )
   {
     # Klappbox mit Kanlen umschalten
     $centry->delete("0", "end");
     foreach $label (
	 sort { $a cmp $b }
	 keys %{$CHANLIST{$curtable}}) 
     {
	$centry->insert("end", $label);
     }
   }

   # --- fr den p+ Button ---
   @curtablelist = sort { $a cmp $b } keys %{$CHANLIST{$curtable}};
   $curtableanz = @curtablelist;
   
   $statustext = "Setze Tabelle: $curtable";
  show_string($statustext);
} # change_table 

# ------------ Funktion zum Wechseln des Kanals -------------
sub tune_plus 
{
  if ($curFreq != 0)
  {

  $settings{FrequencyTune} += 1;
  
  my $setFreq = ($curFreq * 16)/1000 + $settings{FrequencyTune};
  
  unless ($ivtvObj->setFrequency($tunerFD, $settings{TunerNum}, $setFreq))
  {
    die "Error:  changeChannel($curchannel) failed!\n";
  }
  
    $statustext = "Setze Kanal: $curchannel Freq: $curFreq Tune: $settings{FrequencyTune}";
  }
  else
  {
    $statustext = "Tune Frequenz: bitte Kanal whlen!";
  }
  show_string($statustext);
}

sub tune_minus 
{
  if ($curFreq != 0)
  {
    $settings{FrequencyTune} -= 1;
  
    my $setFreq = ($curFreq * 16)/1000 + $settings{FrequencyTune};
  
    unless ($ivtvObj->setFrequency($tunerFD, $settings{TunerNum}, $setFreq))
    {
      die "Error:  changeChannel($curchannel) failed!\n";
    }
    $statustext = "Setze Kanal: $curchannel Freq: $curFreq Tune: $settings{FrequencyTune}";
  }
  else
  {
    $statustext = "Tune Frequenz: bitte Kanal whlen!";
  }
  show_string($statustext);
}

# die Konfigurierten Buttons
sub channel_button {
  $curchannel = $_[0];
  $prognum = $_[1];
  change_channel();
} # channel_button

# -------------- den Player wieder schliessen  ---------------------
sub kill_tv {
 
  if ( $child_tv != 0 )
  {
    kill(SIGQUIT, $child_tv);
    $statustext = "sende SIGQUIT an Pid: $child_tv...";
    show_string($statustext);
    $child_tv = 0;
  }
} # scan button

# -------------- der Kanal-Scan Button  ---------------------
sub scan_next {

  if ($curtablepos >= $curtableanz)
  { 
    $curtablepos =0;
  }

  $curchannel = $curtablelist[ $curtablepos ];
  $statustext = "change_channel($curchannel)... von $curtableanz";
  $curtablepos ++;
  
  show_string($statustext);
  change_channel();
} # scan next

# --- der Kanal next Button ---
sub channel_next {
  $prognum ++;
  if ($prognum > $prog_anz)
  {
   $prognum = 0;
  } 
  $curchannel = $progs_keys[ $prognum ];
  change_channel();
  
}

# --- der Kanal prev Button ---
sub channel_prev {
  $prognum --;
  if ($prognum < 0)
  {
   $prognum = $prog_anz;
  } 
  $curchannel = $progs_keys[ $prognum ];
  change_channel();
}


# --- Kanal Hopping ---
sub channel_hop {
 
  my $child = fork ;
  unless (defined $child)
  {
    # --- fork failed ---
    die "Error:  fork(channel_hop) failed!\n";
  }
  
  # ------ Im Kind hoppen -------
  if ($child == 0) 
  {
    # --- Hopping --- Endlos ---
    while (1)
    {
      $prognum ++;
      if ($prognum > $prog_anz)
      {
       $prognum = 0;
      } 
      $curchannel = $progs_keys[ $prognum ];
      change_channel();
      sleep 7;
    }
  }
  
  # ------ Im Vater Ende ----
  $child_hop = $child;
  
  $statustext = "Hop Kind erzeugt pid=$child_hop !";
  show_string($statustext);
  
} # channel_button


# der Kanal hop stop 
sub channel_stop {
  
  kill(15, $child_hop);
  $statustext = "Hop Kind gettet pid=$child_hop!";
  show_string($statustext);


} # channel_button

sub change_channel {
  $statustext = "Setze Kanal: $curchannel";

  my $freq = $CHANLIST{$settings{FrequencyTable}}->{$curchannel};
  if ($freq)
  {
    my $drfreq = ($freq * 16)/1000 + $settings{FrequencyTune};
    $curFreq = $freq;

    unless ($ivtvObj->setFrequency($tunerFD, $settings{TunerNum}, $drfreq))
    {
       die "Error:  changeChannel($curchannel) failed!\n";
    }
  
    $statustext = "Umschalten: $progs{$curchannel}  Kanal=$curchannel Freq=$freq Tune=$settings{FrequencyTune}";
    
  }
  else
  {
    $statustext =  "[$progs{$curchannel}] -> $curchannel: gibt es nicht in $settings{FrequencyTable}!";
  }
  
  show_string($statustext);
} # change_channel

# ------------ Funktion zum Wechseln des Input -------------
sub change_input 
{
   # _ von der Kommandozeile wieder entfernen
   $_ = $curinput;
   s/_/ /g;

   $settings{Input} = $_;
   
   $curinput = $_;
   
   my $result = $ivtvObj->setInput($tunerFD, $name2input{$curinput});
  
   $statustext = "Setze Input: $curinput -> $name2input{$curinput}";
   show_string($statustext);

   unless( $result)
     {
       die "Error:  setInput($curinput) failed!\n";
     } 
   else
     {
       set_mspmatrix();
     }
  
} # change_input

# ------------ Funktion zum Einlesen der Kartenstatus -------------
sub get_status {
  $statustext = "Kartenstatus lesen...";
  
  if ($tunerFD == 0)
  {
    # nur einmal im Programm! dann schn wieder zu !
    unless( open($tuner, "<$settings{VideoDevice}"))
    {
      $statustext = "Kann Device nicht lesen...";
      return 1;
    }
    $tunerFD = fileno($tuner);
  }

  show_string("Hallo bei hefa-TV!\nopen Tuner=$tuner FD=$tunerFD");
  show_string($line);

  # get the current capabilities.
  my @capabilities = $ivtvObj->getCapabilities($tunerFD);
  if (@capabilities != keys %{$ivtvObj->{capIndexes}})
  {
        error(1, "getCapabilities() failed!");
  }

  if ($capabilities[$ivtvObj->{capIndexes}{driver}] ne "ivtv")
  {
      $settings{UsingIvtvDriver} = 0;  # we can't use the ivtv "enhancements".
      show_string("Warning:  V4l2 driver = '$capabilities[$ivtvObj->{capIndexes}{driver}]'\ndoes not support the ivtv \"enhancements\"!");
      show_string("All codec related options will be ignored.\n");
   }
  else		
  {
     show_string("V4l2 driver = '$capabilities[$ivtvObj->{capIndexes}{driver}]' does\nsupport the ivtv \"enhancements\"!");
     
     show_string(
       "Driver: $capabilities[0]\nCard: $capabilities[1]\nBus_info: $capabilities[2]\nVersion: $capabilities[3]\nCap: $capabilities[4]");
  }
  show_string($line);

 
  my ($aspect, $audio_bitmask, $bframes, $bitrate, $bitrate_peak, 
  	$dnr_mode, $dnr_spatial, $dnr_temporal, $dnr_type, $framerate, 
	$framespergop, $gop_closure, $pulldown, $stream_type) 
	= $ivtvObj->getCodecInfo($tunerFD);
 
  show_string("CodecInfos:");
  show_string("aspect: $aspect");
  show_string("audio_bitmask: $audio_bitmask");
  # show_string("bframes: $bframes");
  # show_string("bitrate: $bitrate");
  show_string("bitrate_peak: $bitrate_peak");
  show_string("dnr_mode: $dnr_mode");
  # show_string("dnr_spatial: $dnr_spatial");
  # show_string("dnr_temporal: $dnr_temporal");
  # show_string("dnr_type: $dnr_type");
  # show_string("dnr_type: $framerate");
  show_string("framespergop: $framespergop");
  show_string("gop_closure: $gop_closure");
  # show_string("pulldown: $pulldown");
  # show_string("stream_type: $stream_type");
  show_string($line);


 if ($settings{UsingIvtvDriver})
 {
      if ($settings{SetMSPMatrix} !~ /^(0|1)$/)
      {
        error(1, "SetMSPMatrix = '$settings{SetMSPMatrix}' is invalid!  It can only be 0 or 1.");
      }
      if ($settings{MSPInput} < 1 || $settings{MSPInput} > 8)
      {
         error(1, "MSPInput = '$settings{MSPInput}' is invalid!  It can only be 1 - 8.");
       }
       if ($settings{MSPOutput} < 0 || $settings{MSPOutput} > 3)
       {
         error(1, "MSPOutput = '$settings{MSPOutput}' is invalid!  It can only be 0 - 3.");
       }
  }
  
  my $str;

  # --- get the current video standard ---
  my $std = $ivtvObj->getStandard($tunerFD);
  if ($std > 0)
  {
    $str = sprintf("Standard ist: 0x%08x", $std);
    show_string($str);
  }
  else
  {
    die "Error: getStandard() failed!\n";
  }
  show_string($line);
  
  # --- get the current input ---
  $input = $ivtvObj->getInput($tunerFD);
  if ($input < 0)
  {
     die "Error: getInput() failed!\n";
  }
  
  $str = sprintf("Input ist: 0x%08x",$input);
  show_string($str);

 my $done=0;
 # --- Standards ---
 show_string("Standards mglich:");
 
 @standards = ();
 for ($i=0; !$done; ++$i)
  {
     my($index,$std_id,$name,$frameperiod_n,$frameperiod_d,$framelines) = $ivtvObj->enumerateStandard($tunerFD, $i);
     if ($index == -1)
     {
       $done = 1;
     }
     else
     {
       $str = sprintf("%d 0x%08x %s %d/%d %d",$index,$std_id,$name,$frameperiod_n,$frameperiod_d,$framelines) ;
       show_string($str);
       push @standards, [($name,$std_id)];
       $name2std{$name} = $std_id;
       if( (($std_id & $std) == $std))
       {
         $curstd = $name;
       }
    }
  }
  show_string($line);

 # --- Standards widget wieder fllen ---
 unless( $settings{RecordMode} )
 {
   $sentry->delete(0, "end");
   foreach my $label (@standards) {
     $sentry->insert("end", $label->[0] );
   }
 }
 
 # --- Inputs ---
 show_string("Inputs mglich:");
 
 @inputs = ();
 for ($done=$i=0; !$done; ++$i)
 {
   my($index,$name,$type,$audioset,$tuner,$std,$status) = $ivtvObj->enumerateInput($tunerFD, $i);
   if ($index == -1)
   {
     $done = 1;
   }
   else
   {
     show_string($i.": ".$name);
     push @inputs, $name;
     $name2input{$name} = $index;
   }
 }
 $curinput = $inputs[$input];
 
 show_string($line);
 
 unless( $settings{RecordMode} )
 {
   # --- widget inputs setzen ---
   $ientry->delete(0, "end");
   foreach $label (@inputs) {
     $ientry->insert("end", $label );
   }
 }
 return 0;
} # status lesen

# Setzt die Standard Vorgaben ohne zu vergleichen
sub set_default_first
{
    $curstd = $settings{VideoStandard};
    change_std(); 
    $curinput = $settings{Input};
    change_input();
    $curtable = $settings{FrequencyTable};
    change_table ();
    $curchannel = $settings{StartKanal};
    change_channel();
}

# immer schn die Filedescriptoren schlieen 
sub my_exit
{
  print "Exit";
  if ($tunerFD)
  {
    close($tuner);
    print ", close Tuner!\n";
  }  
  else
  {
     print ".\n";
  }   
  
  exit $_[0];
}


# --- TV GUI oder nur Aufnahme ---
if ( $settings{RecordMode} )
{
  print "Start der Aufnahme fr $settings{RecTime} Minuten!\n";
  # hier auf geladene Module testen.
  lade_module();
}
else
{
  makeGUI();
  unless( get_status() )  # die Widgets sollen initialisert werden
  {
     set_default_first();
  }
}

  
if ( $settings{RecordMode} )
{
  # --- ganz normal, wie Knopfdruck ---
  start_aufnahme();
  
  # --- Ausgabe der Wartezeit ---
  print "aufnahme $settings{RecTime} Minuten:";
  for (my $x=0; $x<$settings{RecTime}; $x++)
  {
    sleep(60);
    print(".");
  }
  print "fertig!\n";

  # --- kille Aufnahmeprozess ---
  stop_aufnahme();

  # --- fhre Kompression durch ---
  if (  $settings{RecordMode} == 1 )
  {
    start_konv(2, ".mpeg");
  }
  elsif (  $settings{RecordMode} == 2 )
  {
    start_konv(0, ".divx");
  }

  # --- fahre Rechner runter, 1=YES oder 0=NO ---
  if ( $settings{Shutdown} == 1 )
  {
    system $settings{ShutdownCmd};
  }  

}
else
{  
  MainLoop;
}

my_exit(0);


sub encoded_gif {

    # A Base64 encoded transparent GIF.

    # --- mein Taucher :-) ---
    
   my $gif =  <<'END_OF_GIF';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_OF_GIF

    return $gif;

} # end encoded_gif

# --- EOF --- 
# Viel Spass! hefa
